<template>
  <div class="ob-order-template">
    <div class="ob-order-template-header">
      <div class='ob-order-template-header-content'>
        <div class='order-info'>
          <i class='icon hand'></i>
          Заказ PO19 555 1201
          <span>черновик</span>
        </div>
        <div class='order-details'>
          <div class='order-contractor'>
            Исполнитель:
            <ob-inline-select
              ref="contractorSelect"
              v-model="contractor.uuid"
              :items="orderInfo.contractors"
              :inheritWidth="false"
              @input="onContractorSelect"
              label="Выбрать исполнителя"
            >
              <template v-slot="{items}">
                <div :class="['ob-inline-select__list-item', {'top': item.top}]" v-for="item in items" :key="item.uuid" @click="selectContractor(item)">
                  <i v-if="item.icon" :class="['icon', item.icon]" />
                  {{item.title}}
                </div>
              </template>
            </ob-inline-select>
          </div>
          <div class='order-type'>Тип: заказ на перевозку</div>
        </div>
      </div>
    </div>
    <div class="ob-order-template-content">
      <div class="ob-order-template-content-left">
        <slot name="left" />
      </div>
      <div class="ob-order-template-content-right">
        <slot name="right" />
      </div>
    </div>
  </div>
</template>

<script>
import ObInlineSelect  from 'common-components/src/obComponents/obInlineSelect';
export default {
  name: 'ObOrderTemplateCompact',

  components: {
    ObInlineSelect
  },

  props: {
    orderInfo: {
      type: Object,
      required: true
    }
  },

  data() {
    return {
      contractor: {uuid: '', title: ''}
    }
  },
  mounted() {
    if (this.orderInfo.contractor) {
      this.onContractorSelect(this.orderInfo.contractor);
    }
  },

  methods: {
    selectContractor(item) {
      this.contractor.uuid = item.uuid;
      this.onContractorSelect(item.uuid, true);
    },

    onContractorSelect($event, toggle) {
      if (toggle) {
        this.$refs.contractorSelect.toggle();
      }
      const newContractor = this.orderInfo.contractors.find(
        item => item.uuid === $event
      );

      this.contractor.uuid = newContractor.uuid;
      this.contractor.title = newContractor.title;
      this.contractor.icon = newContractor.icon;
      this.$emit('contractorChanged', this.contractor);
    }
  }
}
</script>

<style scoped lang="scss">



$margin-container-top: 12px;
$margin-container-bottom: 20px;
$container-height-top: 80px;
$height-top-menu: 104px;
$height-footer: 30px;

$font-family-roboto: "Roboto", sans-serif;

@mixin font-mixin($font-size, $line-height, $font-weight, $color: inherit, $letter-spacing: 0.2px, $text-transform: none, $text-decoration: none ) {
  font-family: $font-family-roboto;
  font-size: $font-size;
  font-weight: $font-weight;
  line-height: $line-height;
  letter-spacing: $letter-spacing;
  color: $color;
  text-transform: $text-transform;
  text-decoration: $text-decoration;
}

.ob-order-template {
  margin: $margin-container-top 20px $margin-container-bottom;
  background: $background-white;
  border-radius: 3px;
  position: relative;
  width: calc(100% - 40px);
}

.ob-order-template-header {
  display: flex;
  align-items: center;
  min-height: $container-height-top;
  width: 100%;
  padding: 0 20px;
  position: relative;
  z-index: 1;
  background: $background-white;
  box-shadow: 0 0 10px -4px rgba($color-blue-navy-blue,0.6);
}

.ob-order-template-content {
  position: relative;
  width: 100%;
  display: flex;
}

.ob-order-template-content-left {
  width: calc(100% - 316px);
  padding-top: 15px;
}

.ob-order-template-content-right {
  z-index: 2;
  margin-top: -$container-height-top;
  box-shadow: 0 0 10px -4px rgba($color-blue-navy-blue,0.6);
  background: $background-white;
  width: 316px;
  min-height: calc(100vh - (#{$height-top-menu} + #{$height-footer} + 4px));
}

.order-info {
  display: flex;
  align-items: center;
  @include font-mixin(24px, 28px, 700, $components-obOrderTemplateCompact_order_info_font_color);

  span {
    align-self: flex-start;
    @include font-mixin(12px, 20px, 400, $gray-slate, 0.4px, uppercase)
  }

  .icon {
    margin-right: 9px;
    @include font-mixin(12px, 20px, 400, $color-blue-navy-blue)
  }
}

.order-details {
  display: flex;
  align-items: center;
}

.ob-inline-select__list-item {
  display: flex;
  align-items: center;
  font-size: 14px;
  letter-spacing: 0.2px;
  color: $color-text-base;
  padding: 8px 16px;
  cursor: pointer;
  white-space: nowrap;

  &:first-child {
    padding-top: 16px;
  }
  &:last-child {
    padding-bottom: 16px;
  }

  &.top {
    border-bottom: 1px solid rgba($color-grey-border, 0.3);
  }

  .icon {
    margin-right: 5px;
    color: $color-blue-navy-blue;
  }
}
</style>
